package com.ai_center.dragonbreath;


/** This is a RealTimeControlMessage. <p>
 
 It is sent by the breakpoints to all RealTimeControl-listeners.
 
 @author Daniel Weiss
 @version $$
 */
public class RTCMessage
{


    /** The object which has changed. */
    private Object changedObject;

    /** The number of the breakpoint, who sends this message. */
    private int breakpointNumber;

    /** The message of the breakpoint. */
    private String message;


    /** Creates a RealTimeControl Message.<p>

     @param _breakpointNumber The number of the breakpoint, who sends this message.
     @param _message The message of the breakpoint.
     @param _changedObject The object which has changed. 
     */
    public RTCMessage(int _breakpointNumber, String _message,
            Object _changedObject)
    {
        changedObject = _changedObject;
        message = _message;
        breakpointNumber = _breakpointNumber;

    }

    /**
     @return Returns the changedObject.
     */
    public Object getChangedObject()
    {
        return changedObject;
    }

    /**
     @param changedObject The changedObject to set.
     */
    public void setChangedObject(Object changedObject)
    {
        this.changedObject = changedObject;
    }

    /**
     @return Returns the breakpointNumber.
     */
    public int getBreakpointNumber()
    {
        return breakpointNumber;
    }

    /**
     @param breakpointNumber The breakpointNumber to set.
     */
    public void setBreakpointNumber(int level)
    {
        this.breakpointNumber = level;
    }

    /**
     @return Returns the message.
     */
    public String getMessage()
    {
        return message;
    }

    /**
     @param message The message to set.
     */
    public void setMessage(String message)
    {
        this.message = message;
    }
}