
package com.ai_center.dragonbreath.constraintgraph;

/** 
 * Implements a double-linked list to enable the value propagation of 
 * object constraints.
 *
 * @author Alexander Nareyek
 * @version $Revision: 2.0 $
 * @see ObjectConstraint
 */


public class ConnectionReference {

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /** 
     * The link to the object constraint of the connection, or
     * to the variable if it is the first connection.
     */
    public Node node;

    /** 
     * The reference of the previous node.
     */
    public ConnectionReference previous = null;

    /** 
     * The reference of the following node.
     */
    public ConnectionReference next = null;

    /** 
     * Type of the edge to the following node.
     * @see Registry
     */
    public int edgeID;

    /** 
     * Direction of the edge to the following node.
     * @see Registry
     */
    public boolean direction;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************

    /** 
     * Sets the node value.
     * @param node  The initial node value.
     */
    public ConnectionReference(Node node) {
	this.node = node;
    }

}


/* 
 * DO _NOT_ EDIT ANYTHING BELOW THIS POINT! 
 * 
 * $Log: ConnectionReference.java,v $
 * Revision 2.0  2002/09/17 00:33:06  nareyek
 * work on beta version began: resource type, state tasks and precondition tasks introduced
 *
 * Revision 1.1  2002/04/04 04:55:58  nareyek
 * directories costs and constraintgraph introduced
 *
 * Revision 1.3  2002/04/04 03:04:58  nareyek
 * new constraint directory; VariableComparator removed and integrated into Variable
 *
 * Revision 1.2  2001/12/12 11:50:35  nareyek
 * Naming: clearAll -> clearCSP
 * 
 * 
 */
