
package com.ai_center.dragonbreath.constraintgraph;

/** 
 * Graphical interface for a node. 
 * 
 * @author Alexander Nareyek
 * @version 0.1
 */


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import com.ai_center.dragonbreath.GlobalSearchControl;


public class NodeGraphics extends JPanel {
    
    // **********************
    // ***** ATTRIBUTES *****
    // **********************
    
    /** 
     * The Node reference.
     */
    public Node node;

    /** 
     * The Global Search Control reference.
     */
    public GlobalSearchControl gsc;

    /** 
     * The node's x coordinate.
     */
    public int x = 200; 

    /** 
     * The node's y coordinate.
     */
    public int y = 100;

    /** 
     * Main user interaction button.
     */
    public JButton activator;

    

    // *******************
    // ***** METHODS *****
    // *******************

    /** 
     * Updates the size of a node's graphical representation.
     */
    public void updateSize() {
    	Dimension dm = getMinimumSize();
	Dimension dp = getPreferredSize();
	Dimension d = new Dimension(dm.width>dp.width?dm.width:dp.width, 
				    dm.height>dp.height?dm.height:dp.height);
	setBounds(x - d.width / 2, y - d.height / 2, d.width, d.height);
	revalidate();
    }
    
    
    /**
     * The color of the graphic object if unmarked
     */
    java.awt.Color bgColor;
    /**
     * The color of the graphic object if marked
     */
    java.awt.Color markedBgColor;
    
    /**
     * Change the color of object to mark it
     */
    void mark(){
        if (bgColor==null){
            bgColor=getBackground();
            markedBgColor=bgColor.darker();
        }
        setBackground(markedBgColor);
        
         
    }
    
    /**
     * Change color back
     */
    void unmark(){
        if (bgColor==null){
            bgColor=getBackground();
            markedBgColor=bgColor.darker();
        }
        setBackground(bgColor);
        
    }
}
