
package com.ai_center.dragonbreath.constraintgraph;

/** 
 * This object stores graphical data in the case that graphics are
 * not turned on. 
 * 
 * @author Alexander Nareyek
 * @version $Revision: 2.0 $
 */


public class NodeGraphicsCache {

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /** 
     * The node's x coordinate.
     */
    public int x = 0; 

    /** 
     * The node's y coordinate.
     */
    public int y = 0;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************

    /** 
     * Initializes the cache with x/y coordinates for the node's
     * visual placement.
     * @param x  The x coordinate.
     * @param y  The y coordinate.
     */
    public NodeGraphicsCache(int x, int y) {
	this.x = x;
	this.y = y;
    }

}


/* 
 * DO _NOT_ EDIT ANYTHING BELOW THIS POINT! 
 * 
 * $Log: NodeGraphicsCache.java,v $
 * Revision 2.0  2002/09/17 00:33:06  nareyek
 * work on beta version began: resource type, state tasks and precondition tasks introduced
 *
 * Revision 1.1  2002/08/28 07:52:53  nareyek
 * engine can now also be run without a graphical display
 * 
 * 
 */ 
