
package com.ai_center.dragonbreath.constraintgraph;

/**
 * Represents a general node to be used in conventional as well as
 * structural constraint graphs.
 *
 * @author  tim baermann
 * @version $Revision: 2.0 $
 */


public class NodeType {

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /** 
     * The related type ID. This variable is set by the Registry.
     * @see Registry
     */
    public int typeID;

    /** 
     * The variable type's name. Is overwritten by child classes.
     */
    private static String TYPE_NAME = new String("Arbitrary Node");
    

    // *******************
    // ***** METHODS *****
    // *******************
    
    /** 
     * Returns the node's type name.
     */
    public  String getTypeName(){
	return TYPE_NAME;
    }

}



/*
 * DO _NOT_ EDIT ANYTHING BELOW THIS POINT!
 *
 * $Log: NodeType.java,v $
 * Revision 2.0  2002/09/17 00:33:06  nareyek
 * work on beta version began: resource type, state tasks and precondition tasks introduced
 *
 * Revision 1.2  2002/04/11 01:18:52  nareyek
 * IntervalList introduced; TaskObjectConstraint modified
 *
 * Revision 1.1  2002/04/09 23:17:57  teutates
 * NodeType as parentclass for Node added
 *
 */
