
package com.ai_center.dragonbreath.constraintgraph;

/** 
 * Graphical interface for an object constraint. 
 * 
 * @author Alexander Nareyek
 * @version $Revision: 2.0 $ 
 */


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import com.ai_center.dragonbreath.GlobalSearchControl;


public class ObjectConstraintGraphics extends NodeGraphics {
    
    // **********************
    // ***** ATTRIBUTES *****
    // **********************
    
    /** 
     * The object constraint reference.
     */
    private final ObjectConstraint constraint;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************

    /** 
     * Creates basic graphical objects.
     * @param constraint_ref  The related (specialized) 
     *                        ObjectConstraint object.
     * @param gsc_ref The related GlobalSearchControl object.
     */
    protected ObjectConstraintGraphics(ObjectConstraint constraint_ref, 
				       GlobalSearchControl gsc_ref) {

	constraint = constraint_ref;
	gsc = gsc_ref;

	setBackground(Color.cyan);
	setBorder(BorderFactory.createCompoundBorder(BorderFactory.createRaisedBevelBorder(), BorderFactory.createEmptyBorder(1, 1, 1, 1)));
	setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

	JPanel p;
	p = new JPanel();
	p.setBackground(Color.yellow);
	p.setBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4));
	p.setLayout(new BorderLayout());
	activator = new JButton(constraint.getTypeName());
	activator.setMinimumSize(new Dimension(100, 20));
        activator.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    gsc.graphObject.constraintButtonPressed(constraint);
		}});
	activator.setEnabled(false);
	p.add(activator, BorderLayout.CENTER);
	add(p);

    }

    // *******************
    // ***** METHODS *****
    // *******************

    protected void updateCosts() {
    }

}


/* 
 * DO _NOT_ EDIT ANYTHING BELOW THIS POINT! 
 * 
 * $Log: ObjectConstraintGraphics.java,v $
 * Revision 2.0  2002/09/17 00:33:06  nareyek
 * work on beta version began: resource type, state tasks and precondition tasks introduced
 *
 * Revision 1.2  2002/04/04 09:25:36  nareyek
 * general constraint interface included; cost workflow improved
 * 
 * 
 */ 
