
package com.ai_center.dragonbreath.constraints;

/** 
 * This object constraint indicates the variable that
 * provides the current time value.
 *
 * @author Alexander Nareyek
 *
 * @version $Revision: 2.1 $
 *
 * @see Variable
 */


import com.ai_center.dragonbreath.constraintgraph.*;
import com.ai_center.dragonbreath.Registry;


public class CurrentTimeObjectConstraint extends ObjectConstraint {

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /** 
     * The constraint type's name.
     */
    private static final String TYPE_NAME = new String("Current Time");

    /** 
     * The constraint's base graph.
     */
    private static final Embedding BASE_GRAPH = new Embedding(1);


    // *******************
    // ***** METHODS *****
    // *******************

    public void create_graphs() {

	// Creating the base graph

	BASE_GRAPH.addConnectedNode(Registry.VARIABLE, Registry.PLAIN_EDGE, 
				    Registry.INCOMING);

    }

    public String getTypeName() {
	return TYPE_NAME;
    }

    public Embedding getBaseGraph() {
	return BASE_GRAPH;
    }

    public int getExtensionGraphNumber() {
	return 0;
    }

    public Embedding getExtensionGraph(int graphID) {
	return null;
    }

    public int getMaximalConnectionNumber() {
        // There is no maximum for extensions
        return Integer.MAX_VALUE;
     }

}
