/*
 * ProportionConstraintGraphics.java
 *
 * Created on 20. Februar 2003, 22:42
 */

package com.ai_center.dragonbreath.constraints;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import com.ai_center.dragonbreath.constraintgraph.*;
import com.ai_center.dragonbreath.GlobalSearchControl;
/**
 *
 * @author  Student
 */
public class ExponentialConstraintGraphics extends ConventionalConstraintGraphics {
    
     // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /** 
     * The related ProportionConstraint object.
     */
    public ExponentialConstraint exponentialConstraint;

    /** 
     * Displays the constraint's range.
     */
    public JLabel label;
    /** 
     * The panel for the coefficient display.
     */
    public JPanel coefficientPanel;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************

    /** 
     * Creates basic graphical objects.
     * @param constraint  The related ProportionConstraint object.
     * @param gsc The related GlobalSearchControl object.
     */
    public ExponentialConstraintGraphics(ExponentialConstraint constraint, 
				   GlobalSearchControl gsc) {
	super(constraint, gsc);
	exponentialConstraint = constraint;

	add(Box.createRigidArea(new Dimension(0,2)));
	coefficientPanel = new JPanel();
	coefficientPanel.setLayout(new BorderLayout());
	coefficientPanel.setBackground(Color.cyan);
	label = new JLabel();
	updateExponent();
	label.setHorizontalAlignment(SwingConstants.CENTER);
	coefficientPanel.add(label, BorderLayout.CENTER);
	add(coefficientPanel);

    }


    // *******************
    // ***** METHODS *****
    // *******************

    /** 
     * Updates the display of the constraint's Coefficient data.
     */
    public void updateExponent() {
	label.setText(" "+exponentialConstraint.getExponent()+" ");
    }

}
