
package com.ai_center.dragonbreath.constraints.discreteresourceconstraint;

/** 
 * List of intervals ordered according to their subjective capacity costs
 * (highest first).
 *
 * @author Alexander Nareyek
 * @version $Revision: 2.1 $
 *
 * @see utilities.OrderedShiftDLL
 */


import com.ai_center.dragonbreath.utilities.IntervalListElement;
import com.ai_center.dragonbreath.utilities.OrderedShiftDLL;


public class OrderedCapacityCostsIntervalList extends OrderedShiftDLL {

    // *******************
    // ***** METHODS *****
    // *******************

    public int compareElements(Object element1, Object element2) {

	long costs1 = ((DRCInterval) ((IntervalListElement) element1).getElement()).capacityCosts;
	long costs2 = ((DRCInterval) ((IntervalListElement) element2).getElement()).capacityCosts;

	if (costs1 > costs2) {
	    return 1;
	} else {
	    if (costs1 < costs2) {
		return -1;
	    } else {
		return 0;
	    }
	}

    }

}


/* 
 * DO _NOT_ EDIT ANYTHING BELOW THIS POINT! 
 * 
 * $Log: OrderedCapacityCostsIntervalList.java,v $
 * Revision 2.1  2004/04/07 12:57:55  weissd
 * Changed datastructure for better observing.
 *
 * Revision 2.0  2002/09/17 00:33:06  nareyek
 * work on beta version began: resource type, state tasks and precondition tasks introduced
 *
 * Revision 1.1  2002/06/15 08:14:13  nareyek
 * DiscreteResourceConstraint can now handle different levels of tasks' consumptions; DiscreteResourceConstraint's internal structures extended; Task changed into ActionTask with an additional consumption variable
 * 
 * 
 */
