
package com.ai_center.dragonbreath.constraints.discreteresourceconstraint;

/** 
 * List of DRCTasks ordered according to their capacity costs
 * (highest first).
 *
 * @author Alexander Nareyek
 * @version $Revision: 2.1 $
 *
 * @see utilities.OrderedShiftDLL
 */


import com.ai_center.dragonbreath.utilities.OrderedShiftDLL;


public class OrderedCapacityCostsTaskList extends OrderedShiftDLL {

    // *******************
    // ***** METHODS *****
    // *******************

    public int compareElements(Object element1, Object element2) {

	long costs1 = ((DRCTask) element1).capacityCosts;
	long costs2 = ((DRCTask) element2).capacityCosts;

	if (costs1 > costs2) {
	    return 1;
	} else {
	    if (costs1 < costs2) {
		return -1;
	    } else {
		return 0;
	    }
	}

    }

}
