
package com.ai_center.dragonbreath.constraints.discreteresourceconstraint;

/** 
 * List of intervals ordered according to their number of claims (first
 * priority; highest first) and length (second priority; longest first).
 *
 * @author Alexander Nareyek
 * @version $Revision: 2.1 $
 *
 * @see utilities.OrderedShiftDLL
 */


import com.ai_center.dragonbreath.utilities.IntervalListElement;
import com.ai_center.dragonbreath.utilities.OrderedShiftDLL;


public class OrderedClaimsIntervalList extends OrderedShiftDLL {

    // *******************
    // ***** METHODS *****
    // *******************

    public int compareElements(Object element1, Object element2) {
	long claims1 = 
	    ((DRCInterval) ((IntervalListElement) element1).getElement()).claims;
	long claims2 = 
	    ((DRCInterval) ((IntervalListElement) element2).getElement()).claims;
	if (claims1 > claims2) {
	    return 1;
	} else {
	    if (claims1 < claims2) {
		return -1;
	    } else {
		long length1 = ((IntervalListElement) element1).getEnd() 
		    - ((IntervalListElement) element1).getBeginning();
		long length2 = ((IntervalListElement) element2).getEnd() 
		    - ((IntervalListElement) element2).getBeginning();
		if (length1 > length2) {
		    return 1;
		} else {
		    if (length1 < length2) {
			return -1;
		    } else {
			return 0;
		    }
		}
	    }
	}
    }

}


/* 
 * DO _NOT_ EDIT ANYTHING BELOW THIS POINT! 
 * 
 * $Log: OrderedClaimsIntervalList.java,v $
 * Revision 2.1  2004/04/07 12:57:54  weissd
 * Changed datastructure for better observing.
 *
 * Revision 2.0  2002/09/17 00:33:06  nareyek
 * work on beta version began: resource type, state tasks and precondition tasks introduced
 *
 * Revision 1.2  2002/06/22 05:58:26  nareyek
 * DiscreteResourceConstraint's heuristics improved
 *
 * Revision 1.1  2002/06/15 08:14:13  nareyek
 * DiscreteResourceConstraint can now handle different levels of tasks' consumptions; DiscreteResourceConstraint's internal structures extended; Task changed into ActionTask with an additional consumption variable
 * 
 * 
 */
