
package com.ai_center.dragonbreath.constraints.stateresourceconstraint;


import com.ai_center.dragonbreath.constraintgraph.Variable;
import com.ai_center.dragonbreath.constraints.PreconditionTaskObjectConstraint;


/**
 * A StateResourceResourceConstraint's internal representation of a
 * precondition task that has been assigned to it. The sub-classes
 * have specialized versions inheriting this.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.4 $
 */
public class SRCPreconditionTask
{

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /**
     * The related precondition task constraint with the connection to the
     * task variables.
     */
    public PreconditionTaskObjectConstraint taskConstraint;

    /**
     * The related variable for the resource type of the task.
     */
    public Variable resourceTypeVariable = null;
    /**
     * The internally stored value copy of the task's resource type variable.
     */
    public long resourceType = 0;


    // *******************
    // ***** METHODS *****
    // *******************

    /**
     * Checks if the precondition ist fullfilled. This function has to be
     * overwritten by a specialized SRCPreconditionTask-Version.
     * @return
     */
    public int checkPrecondition()
    {
        throw new Error( "checkPrecondition() undefined for this PreconditionType" );
    }

}
