
package com.ai_center.dragonbreath.constraints.stateresourceconstraint;


import com.ai_center.dragonbreath.constraintgraph.Variable;
import com.ai_center.dragonbreath.constraints.StateTaskObjectConstraint;


/**
 * A StateResourceResourceConstraint's internal representation of a
 * state task that has been assigned to it. The sub-classes have
 * specialized versions inheriting this.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.3 $
 */
public class SRCStateTask
{

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /**
     * The related state task constraint with the connection to the task
     * variables.
     */
    public StateTaskObjectConstraint taskConstraint;

    /**
     * The related variable for the resource type of the task.
     */
    public Variable resourceTypeVariable = null;
    /**
     * The internally stored value copy of the task's resource type variable.
     */
    public long resourceType = 0;

}
