
package com.ai_center.dragonbreath.constraints.stateresourceconstraint.numericalheapsrc;

/** 
 * A NumericalHeapSRC's internal representation of a connected state task.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.1 $
 */


import com.ai_center.dragonbreath.constraints.stateresourceconstraint.*;
import com.ai_center.dragonbreath.constraintgraph.Variable;
import com.ai_center.dragonbreath.utilities.OrderedShiftDLLElement;


public class NumHSRCStateTask extends SRCStateTask {

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /** 
     * The related variable for the contribution of the task.
     */
    public Variable contributionVariable;
    /**
     * The real-valued number of the contribution variable.
     */
    public double contribution;

    /**
     * The back link to the NumericalHeapSRC's taskList element.
     */
    public OrderedShiftDLLElement taskLE = null;


    // *******************
    // ***** METHODS *****
    // *******************

    /**
     * Returns a string of the task's contribution.
     */
    public String toString() {
        return "C(" + contribution + ")";
    }

}
