
package com.ai_center.dragonbreath.constraints.stateresourceconstraint.numericalheapsrc;

/** 
 * List of NumHSRCStateTasks ordered according to their heap cost
 * contribution (highest first).
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.1 $
 *
 * @see utilities.OrderedShiftDLL
 */


import com.ai_center.dragonbreath.utilities.OrderedShiftDLL;


public class OrderedHeapCostsTaskList extends OrderedShiftDLL {

    // *******************
    // ***** METHODS *****
    // *******************

    public int compareElements(Object element1, Object element2) {

	double costs1 = ((NumHSRCStateTask) element1).contribution;
	double costs2 = ((NumHSRCStateTask) element2).contribution;

	if (costs1 > costs2) {
	    return 1;
	} else {
	    if (costs1 < costs2) {
		return -1;
	    } else {
		return 0;
	    }
	}

    }

}
