
package com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc;


import java.util.*;


/**
 * A SymbolicSRC's internal representation of an event that can change the
 * resource's state.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.3 $
 */
public class SymSRCEvent
{

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /**
     * The name of the event.
     */
    public String name;

    /**
     * The ID of the event.
     */
    public int ID;

    /**
     * List of states for which this event is a synergy part.
     */
    public LinkedList synergyEvents = null;

    /**
     * List of events which contribute to this event as a synergy effect.
     */
    public LinkedList subEvents = null;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************

    /**
     * Initializes the state.
     * @param name  The name for the state.
     */
    public SymSRCEvent( String name )
    {
        this.name = name;
    }


    // *******************
    // ***** METHODS *****
    // *******************

    /**
     * Returns a string with the event's ID.
     */
    public String toString()
    {
        if ( name != null )
        {
            return name;
        }
        else
        {
            return ( new Integer( ID ) ).toString();
        }
    }

}
