
package com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc;


import java.util.HashSet;


/**
 * An interval representation for a SymbolicSRC's state projection.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.3 $
 */
public class SymSRCInterval
{


    // **********************
    // ***** ATTRIBUTES *****
    // **********************


    /**
     * The event that might cause a state change at the beginning of
     * the interval;
     */
    public SymSRCEvent event;

    /**
     * The state over the whole interval.
     */
    public SymSRCState state;

    /**
     * The state tasks at the beginning of the interval.
     */
    public HashSet stateTasks = new HashSet();

    /**
     * The precondition tasks in the interval.
     */
    public HashSet preconditionTasks = new HashSet();


    // *******************
    // ***** METHODS *****
    // *******************


    /**
     * Returns a string including a description of the event, state and tasks.
     */
    public String toString()
    {
        return "(" + event + ") -> " + state + " " + stateTasks.toString()
            + " " + preconditionTasks.toString();
    }


}
