
package com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc;


import com.ai_center.dragonbreath.constraints.stateresourceconstraint.*;
import com.ai_center.dragonbreath.constraintgraph.Variable;
import com.ai_center.dragonbreath.utilities.IntervalListElement;
import com.ai_center.dragonbreath.utilities.OrderedShiftDLLElement;


/**
 * A SymbolicSRC's internal representation of a connected precondition task.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.7 $
 */
public class SymSRCPreconditionTask extends SRCPreconditionTask
{


    // **********************
    // ***** ATTRIBUTES *****
    // **********************


    /**
     * The related variable for the temporal reference of the task.
     */
    public Variable tempVariable;
    /**
     * The internally stored value copy of the task's temporal
     * reference variable.
     */
    public long tempValue;

    /**
     * The related variable for the state of the task.
     */
    public Variable stateVariable;
    /**
     * The internally stored value copy of the task's state
     * variable.
     */
    public int state;

    /**
     * The interval this task is located in.
     */
    public IntervalListElement intervalReference;

    /**
     * The subjective precondition failure costs.
     */
    public long preconditionCosts = 0;

    /**
     * The back link to the SymbolicSRC's preconditionFailureList element.
     */
    public OrderedShiftDLLElement preconditionFailureLE = null;

    /**
     * Indicates whether the precondition task is part of a world transition.
     */
    public boolean partOfWorldTransition;


    // *******************
    // ***** METHODS *****
    // *******************


    /**
     * Returns a string including a description of the temporal reference,
     * tested state and precondition failure costs.
     */
    public String toString()
    {
        return "(" + SymbolicSRC.retrieveState( resourceType , state ) + "@" + tempValue + "?)->" + preconditionCosts;
    }


    /**
     * Checks if the precondition ist fullfilled.
     * @return
     */
    public int checkPrecondition()
    {
        if ( preconditionCosts == 0 )
        {
            return 0;
        }
        else
        {
            return 1;
        }
    }


}
