
package com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc;


import java.util.Collection;
import java.util.Hashtable;


/**
 * A SymbolicSRC's internal representation of a state.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.6 $
 */
public class SymSRCState
{

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /**
     * The name of the state.
     */
    public String name;

    /**
     * The ID of the state.
     */
    public int ID;

    /**
     * Indicates if the state is to be monitored for the transition
     * constraint.
     */
    public boolean watched = false;

    /**
     * Hashtable from events to possible transitions from predecessor states.
     */
    public Hashtable predecessorStates = null;
    /**
     * A collection view of the possible transitions from predecessor states.
     */
    public Collection predecessorStatesCollection = null;

    /**
     * Hashtable from events to possible transitions to successor states.
     */
    public Hashtable successorStates = null;
    /**
     * A collection view of the possible transitions to successor states.
     */
    public Collection successorStatesCollection = null;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************

    /**
     * Initializes the state.
     * @param name  The name for the state.
     */
    public SymSRCState( String name )
    {
        this.name = name;
    }


    // *******************
    // ***** METHODS *****
    // *******************

    /**
     * Returns the state's name. If the state is to be watched, a
     * star is appended.
     */
    public String toString()
    {
        if ( watched )
        {
            return new String( name + "*" );
        }
        else
        {
            return name;
        }
    }

}
