
package com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc;

/** 
 * A SymbolicSRC's internal representation of a connected state task.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.3 $
 */


import com.ai_center.dragonbreath.constraints.stateresourceconstraint.*;
import com.ai_center.dragonbreath.constraintgraph.Variable;
import com.ai_center.dragonbreath.utilities.IntervalListElement;


public class SymSRCStateTask extends SRCStateTask {

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /** 
     * The related variable for the temporal reference of the task.
     */
    public Variable tempVariable;
    /**
     * The internally stored value copy of the task's temporal 
     * reference variable.
     */
    public long tempValue;

    /** 
     * The related variable for the contribution of the task.
     */
    public Variable contributionVariable;
    /**
     * The event corresponding to the value of the task's contribution 
     * variable.
     */
    public SymSRCEvent contribution;

    /**
     * The interval started by this state task.
     */
    public IntervalListElement intervalReference;

    /**
     * Indicates whether the state task is part of a world transition.
     */
    public boolean partOfWorldTransition;


    // *******************
    // ***** METHODS *****
    // *******************

    /**
     * Returns a string including a description of the temporal reference
     * and contribution.
     */
    public String toString() {
        return "C(" + contribution + ")@" + tempValue;
    }

}
