
package com.ai_center.dragonbreath.constraints.taskconstraint;

/** 
 * List of TemporalRelations ordered according to their temporal
 * inconsistency costs (highest first).
 *
 * @author Alexander Nareyek
 * @version $Revision: 2.2 $
 *
 * @see utilities.OrderedShiftDLL
 */


import com.ai_center.dragonbreath.utilities.OrderedShiftDLL;


public class OrderedTemporalRelationCostsRelationList extends OrderedShiftDLL {

    // *******************
    // ***** METHODS *****
    // *******************

    public int compareElements(Object element1, Object element2) {

	int costs1prio = 
	    ((TCTemporalRelationInstance) element1).externalTaskMoveCount;
	int costs2prio = 
	    ((TCTemporalRelationInstance) element2).externalTaskMoveCount;
	long costs1 = ((TCTemporalRelationInstance) element1).costs;
	long costs2 = ((TCTemporalRelationInstance) element2).costs;

	if (costs1prio > costs2prio) {
	    return 1;
	} else {
	    if (costs1prio < costs2prio) {
		return -1;
	    } else {
		if (costs1 > costs2) {
		    return 1;
		} else {
		    if (costs1 < costs2) {
			return -1;
		    } else {
			return 0;
		    }
		}
	    }
	}
    }

}
