
package com.ai_center.dragonbreath.constraints.taskconstraint;


/**
 * A TaskConstraint's internal representation of an action type's
 * action task.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.5 $
 */
public class TCActionTask extends TCTask
{

    // **********************
    // ***** ATTRIBUTES *****
    // **********************


    /**
     * The required operation ID for the action task.
     */
    public long operation = 0;

    /**
     * The required duration for the action task.
     */
    public long duration = 0;

    /**
     * The required consumption for the action task.
     */
    public double consumption = 0.0;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************


    /**
     * Initializes the action task.
     * @param resourceType  The required resource type for the action task.
     * @param operation  The required operation ID for the action task.
     * @param duration  The required duration for the action task.
     * @param consumption  The required consumption for the action task.
     */
    public TCActionTask( long resourceType , long operation , long duration ,
        double consumption )
    {
        this.resourceType = resourceType;
        this.operation = operation;
        this.duration = duration;
        this.consumption = consumption;
    }


    // *******************
    // ***** METHODS *****
    // *******************


    /**
     * Prints the required resource type, operation ID, duration and
     * consumption.
     */
    public String toString()
    {
        return new String( "<RT: " + resourceType + " OP: " + operation
            + " D: " + duration + " CO: " + consumption + ">" );
    }


}
