
package com.ai_center.dragonbreath.constraints.taskconstraint;

/**
 * A TaskConstraint's internal representation of an action type's
 * precondition task.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.3 $
 */
public class TCPreconditionTask extends TCTask
{

    // **********************
    // ***** ATTRIBUTES *****
    // **********************


    /**
     * The required state to be checked for by the precondition task.
     */
    public long state = 0;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************


    /**
     * Initializes the precondition task.
     * @param resourceType  The required resource type for the task.
     * @param state  The required state to be checked for by the task.
     */
    public TCPreconditionTask( long resourceType , long state )
    {
        this.resourceType = resourceType;
        this.state = state;
    }


    // *******************
    // ***** METHODS *****
    // *******************


    /**
     * Prints the required resource type and state.
     */
    public String toString()
    {
        return new String( "<RT: " + resourceType + " ST: " + state + ">" );
    }


}
