
package com.ai_center.dragonbreath.constraints.taskconstraint;


/**
 * A TaskConstraint's internal representation of an action type's
 * state task.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.3 $
 */
public class TCStateTask extends TCTask
{


    // **********************
    // ***** ATTRIBUTES *****
    // **********************


    /**
     * The required contribution for the state task.
     */
    public long contribution = 0;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************


    /**
     * Initializes the state task.
     * @param resourceType  The required resource type for the state task.
     * @param contribution  The required contribution for the state task.
     */
    public TCStateTask( long resourceType , long contribution )
    {
        this.resourceType = resourceType;
        this.contribution = contribution;
    }


    // *******************
    // ***** METHODS *****
    // *******************


    /**
     * Prints the required resource type and contribution.
     */
    public String toString()
    {
        return new String( "<RT: " + resourceType + " C: "
            + contribution + ">" );
    }


}
