
package com.ai_center.dragonbreath.constraints.transitionconstraint;

import com.ai_center.dragonbreath.constraints.StateResourceConstraint;
import com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc.SymSRCResourceType;


/**
 * A TransitionConstraint's internal representation of a state resource's
 * event type that may contribute to trigger transitions.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.2 $
 */
public class TCEventType
{

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /**
     * The affected state resource type.
     */
    public long resourceType = 0;

    /**
     * The ID/value of the event affecting the state resource.
     */
    public long event = 0;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************

    /**
     * Initializes the event type.
     * @param resourceType  The affected state resource type.
     * @param event  The ID/value of the event affecting the state resource.
     */
    public TCEventType( long resourceType , long event )
    {
        this.resourceType = resourceType;
        this.event = event;
    }


    // *******************
    // ***** METHODS *****
    // *******************

    /**
     * Prints the required resource and event type.
     */
    public String toString()
    {
        SymSRCResourceType symSRCResourceType = (SymSRCResourceType)StateResourceConstraint.getResourceTypeDefinition( (int)resourceType , StateResourceConstraint.SYMBOLIC_SRC );
        return new String( symSRCResourceType.getEvent( (int)event ) + "(" + symSRCResourceType.getName() + ")" );
    }

}
