
package com.ai_center.dragonbreath.constraints.transitionconstraint;


import java.util.HashSet;

import com.ai_center.dragonbreath.constraints.StateResourceConstraint;
import com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc.SymSRCResourceType;


/**
 * A TransitionConstraint's internal representation of an occuring state
 * that has been announced to the TransitionConstraint.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.7 $
 */
public class TCState
{

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /**
     * The state resource constraint that has announced the state.
     */
    public StateResourceConstraint src;

    /**
     * The corresponding state type.
     */
    public TCStateType stateType;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************

    /**
     * Initializes the state type.
     * @param src  The state resource constraint that has announced the state.
     * @param stateType  The type of the state.
     */
    public TCState( StateResourceConstraint src , TCStateType stateType )
    {
        this.src = src;
        this.stateType = stateType;
    }


    // *******************
    // ***** METHODS *****
    // *******************

    /**
     * Prints the required resource and state type.
     */
    public String toString()
    {
        SymSRCResourceType symSRCResourceType = (SymSRCResourceType)StateResourceConstraint.getResourceTypeDefinition( (int)stateType.resourceType , StateResourceConstraint.SYMBOLIC_SRC );
        return new String( symSRCResourceType.getState( (int)stateType.state ) + "(" + symSRCResourceType.getName() + ")" );
    }

}
