
package com.ai_center.dragonbreath.constraints.transitionconstraint;


import java.util.HashSet;

import com.ai_center.dragonbreath.constraints.StateResourceConstraint;
import com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc.SymSRCResourceType;


/**
 * A TransitionConstraint's internal representation of a state resource's
 * state type.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.1 $
 */
public class TCStateType
{

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /**
     * The required state resource type.
     */
    public long resourceType = 0;

    /**
     * The ID/value of the state resource's state.
     */
    public long state = 0;

    /**
     * The set of transition types this state is a part of.
     */
    public HashSet transitionTypes = new HashSet();


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************

    /**
     * Initializes the state type.
     * @param resourceType  The required state resource type.
     * @param state  The ID/value of the state resource's state.
     */
    public TCStateType( long resourceType , long state )
    {
        this.resourceType = resourceType;
        this.state = state;
    }


    // *******************
    // ***** METHODS *****
    // *******************

    /**
     * Prints the required resource and state type.
     */
    public String toString()
    {
        SymSRCResourceType symSRCResourceType = (SymSRCResourceType)StateResourceConstraint.getResourceTypeDefinition( (int)resourceType , StateResourceConstraint.SYMBOLIC_SRC );
        return new String( symSRCResourceType.getState( (int)state ) + "(" + symSRCResourceType.getName() + ")" );
    }

}
