
package com.ai_center.dragonbreath.constraints.transitionconstraint;


import java.util.*;

import com.ai_center.dragonbreath.constraintgraph.ConventionalConstraint;
import com.ai_center.dragonbreath.utilities.IntervalListElement;


/**
 * A TransitionConstraint's internal representation of a transition
 * instance.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.5 $
 */
public class TCTransition
{


    // **********************
    // ***** ATTRIBUTES *****
    // **********************


    /**
     * The related transition type.
     */
    public TCTransitionType transitionType;

    /**
     * The interval with which the transition starts/happens.
     */
    public IntervalListElement ile;

    /**
     * The action object constraint which realizes the transition.
     */
    public ConventionalConstraint actionConstraint;


    // ************************
    // ***** CONSTRUCTORS *****
    // ************************


    /**
     * Initializes a new transition.
     * @param transitionType  The related transition type.
     * @param ile  The interval with which the transition starts/happens.
     */
    public TCTransition( TCTransitionType transitionType , IntervalListElement ile )
    {
        this.transitionType = transitionType;
        this.ile = ile;
    }


    // *******************
    // ***** METHODS *****
    // *******************


    /**
     * Prints the transition type and the occurrence time.
     */
    public String toString()
    {
        return new String( transitionType + " @" + ile.getBeginning() );
    }


}
