
package com.ai_center.dragonbreath.costs;

/** 
 * This special CostMapping applies BigDecimal factors after a binary
 * transformation of a constraint's costs.
 *
 * @author Alexander Nareyek
 * @version $Revision: 2.0 $ 
 */


import java.math.BigInteger;
import java.math.BigDecimal;


public class FactorBinaryCostMapping extends FactorCostMapping {

    // *******************
    // ***** METHODS *****
    // *******************

    public BigInteger calculateObjectiveCosts(CostFunctionReference 
					      costFunctionReference) {
	BigDecimal binaryCosts;

	if (costFunctionReference.constraint.getCosts(costFunctionReference.costID) > 0) {
	    binaryCosts = ONE;
	} else {
	    binaryCosts = ZERO;
	}
	return binaryCosts.multiply((BigDecimal) costFunctionReference.costMappingOptions).toBigInteger();
    }

}


/* 
 * DO _NOT_ EDIT ANYTHING BELOW THIS POINT! 
 * 
 * $Log: FactorBinaryCostMapping.java,v $
 * Revision 2.0  2002/09/17 00:33:06  nareyek
 * work on beta version began: resource type, state tasks and precondition tasks introduced
 *
 * Revision 1.2  2002/05/24 18:04:59  nareyek
 * cost-mapping classes can now be added dynamically
 *
 * Revision 1.1  2002/04/09 01:19:37  nareyek
 * Every cost item can now have a mapping; constraints can have multiple costs
 * 
 * 
 */
