
package com.ai_center.dragonbreath.costs;


import com.ai_center.dragonbreath.utilities.OrderedShiftDLL;


/**
 * This object maintains an ordered list of constraints (via their
 * costFunctionReferences). The ordering is along decreasing objective
 * costs.
 *
 * @author Alexander Nareyek
 * @version $Revision: 2.1 $
 *
 * @see utilities.OrderedShiftDLL
 * @see CostFunctionReference
 */
public class OrderedCostFunctionReferenceList extends OrderedShiftDLL
{

    // *******************
    // ***** METHODS *****
    // *******************

    public int compareElements( Object element1 , Object element2 )
    {
        return ((CostFunctionReference)element1).objectiveCosts.compareTo(((CostFunctionReference)element2).objectiveCosts);
    }

}
