
package com.ai_center.dragonbreath.costs;

/** 
 * This special CostMapping applies a square function after the constraint's 
 * costs were multiplied by a BigDecimal factor.
 *
 * @author Alexander Nareyek
 * @version $Revision: 2.0 $ 
 */


import java.math.BigInteger;
import java.math.BigDecimal;


public class SquareFactorCostMapping extends FactorCostMapping {

    // *******************
    // ***** METHODS *****
    // *******************

    public BigInteger calculateObjectiveCosts(CostFunctionReference 
					      costFunctionReference) {
	BigDecimal factoredCosts = BigDecimal.valueOf(costFunctionReference.constraint.getCosts(costFunctionReference.costID)).multiply((BigDecimal) costFunctionReference.costMappingOptions);
	return factoredCosts.multiply(factoredCosts).toBigInteger();
    }

}


/* 
 * DO _NOT_ EDIT ANYTHING BELOW THIS POINT! 
 * 
 * $Log: SquareFactorCostMapping.java,v $
 * Revision 2.0  2002/09/17 00:33:06  nareyek
 * work on beta version began: resource type, state tasks and precondition tasks introduced
 *
 * Revision 1.1  2002/05/24 18:04:59  nareyek
 * cost-mapping classes can now be added dynamically
 * 
 * 
 */ 
