
package com.ai_center.dragonbreath.examples.scheduling;

/** 
 * Guides through the scheduling sample application of the <a href="http://www.ai-center.com/projects/dragonbreath/"><font face="Times">DragonBreath</font> engine</a>.
 *
 * @author Alexander Nareyek
 * @version $Revision: 1.2 $
 */


import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;

import com.ai_center.dragonbreath.Registry;
import com.ai_center.dragonbreath.examples.utilities.ExampleDisplay;


public class Guide extends ExampleDisplay {

    public Guide() {

	// Initializing text display
	
	super("Scheduling Example", "scheduling", "Scheduling.java");
	appendIntroduction("This sample program shows how to use the constraints \"DiscreteResourceConstraint\" and \"TaskConstraint\" to solve a simple scheduling problem. The \"DiscreteResourceConstraints\" required by the problem definition are automatically added by structural repairs of the \"TaskConstraints\".");
	appendIntroduction("\n\nThe solution process is run 100 times, and some statistics on these runs are reported.");

	// Run example

	Scheduling example = new Scheduling();
	example.main(null);	

    }

}
