/*
 * FluffFactoryAA.java
 *
 * Created on 21. Februar 2003, 13:40
 */
package com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints;

import com.ai_center.dragonbreath.Registry;
import com.ai_center.dragonbreath.constraintgraph.*;


/**
 * Example Class to test Structural Constraints.  Represents a Factory to
 * produce Fluff
 * 
 * @version $Revision: 1.2 $
 * @author tim baermann
 */
public class FluffFactoryAAAObjectConstraint extends ObjectConstraint {
    //~ Static variables/initializers ******************************************

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /** The constraint type's name. */
    private static final String TYPE_NAME = new String("AAA");

    /** The constraint's base graph. */
    private static final Embedding BASE_GRAPH = new Embedding(3);

    /** The constraint's extension. */
    private static final Embedding EXTENSION_GRAPH = new Embedding(1);

    //~ Methods ****************************************************************

    public Embedding getBaseGraph() {
        return BASE_GRAPH;
    }


    public Embedding getExtensionGraph(int graphID) {
        return null; //EXTENSION_GRAPH;
    }


    public int getExtensionGraphNumber() {
        return 0;
    }


    public int getMaximalConnectionNumber() {
        return 3;
    }


    public String getTypeName() {
        return TYPE_NAME;
    }


    // *******************
    // ***** METHODS *****
    // *******************
    public void create_graphs() {
        // Creating the base graph
        BASE_GRAPH.addConnectedNode(Registry.VARIABLE, Registry.CONSTANT_EDGE, 
                                    Registry.INCOMING);
        BASE_GRAPH.addConnectedNode(Registry.VARIABLE, 
                                    RegistryConstants.CRUFT_EDGE, 
                                    Registry.INCOMING);

        BASE_GRAPH.addConnectedNode(Registry.VARIABLE, 
                                    RegistryConstants.FLUFF_EDGE, 
                                    Registry.INCOMING);

        /*
           EXTENSION_GRAPH.addConnectedNode(Registry.VARIABLE, 
                       Registry.CRUFT_EDGE, 
                       Registry.INCOMING);*/
    }
}