/*
 * FluffFactoryAA.java
 *
 * Created on 21. Februar 2003, 13:40
 */

package com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints;
import com.ai_center.dragonbreath.constraintgraph.*;
import com.ai_center.dragonbreath.Registry;
/**
 * Example Class to test Structural Constraints. 
 * Represents an AA Factory to produce Fluff
 *
 * @author  tim baermann
 * @version $Revision: 1.2 $
 */
public class FluffFactoryAAObjectConstraint extends ObjectConstraint {
  // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /** 
     * The constraint type's name.
     */
    private static final String TYPE_NAME = new String("AA");

    /** 
     * The constraint's base graph.
     */
    private static final Embedding BASE_GRAPH = new Embedding(2);


    // *******************
    // ***** METHODS *****
    // *******************

    public void create_graphs() {

	// Creating the base graph

	BASE_GRAPH.addConnectedNode(Registry.VARIABLE, 
				    RegistryConstants.CRUFT_EDGE, 
				    Registry.INCOMING);BASE_GRAPH.addConnectedNode(Registry.VARIABLE, 
				    RegistryConstants.FLUFF_EDGE, 
				    Registry.INCOMING);
    }

    public String getTypeName() {
	return TYPE_NAME;
    }

    public Embedding getBaseGraph() {
	return BASE_GRAPH;
    }

    public int getExtensionGraphNumber() {
	return 0;
    }

    public Embedding getExtensionGraph(int graphID) {
	return null;
    }

    public int getMaximalConnectionNumber() {
	
	return 2;
    }
}
