/*
 * FluffFactoryAA.java
 *
 * Created on 21. Februar 2003, 13:40
 */
package com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints;

import com.ai_center.dragonbreath.Registry;
import com.ai_center.dragonbreath.constraintgraph.*;


/**
 * Example Class to test Structural Constraints.  Represents a Factory to
 * produce Fluff
 * 
 * @version $Revision: 1.2 $
 * @author tim baermann
 */
public class FluffFactoryAObjectConstraint extends ObjectConstraint {
    //~ Static variables/initializers ******************************************

    // **********************
    // ***** ATTRIBUTES *****
    // **********************

    /** The constraint type's name. */
    private static final String TYPE_NAME = new String("A");

    /** The constraint's base graph. */
    private static final Embedding BASE_GRAPH = new Embedding(2);

    //~ Methods ****************************************************************

    public Embedding getBaseGraph() {
        return BASE_GRAPH;
    }


    public Embedding getExtensionGraph(int graphID) {
        return null;
    }


    public int getExtensionGraphNumber() {
        return 0;
    }


    public int getMaximalConnectionNumber() {
        return 2;
    }


    public String getTypeName() {
        return TYPE_NAME;
    }


    // *******************
    // ***** METHODS *****
    // *******************
    public void create_graphs() {
        // Creating the base graph
        BASE_GRAPH.addConnectedNode(Registry.VARIABLE, 
                                    RegistryConstants.CRUFT_EDGE, 
                                    Registry.INCOMING);
        BASE_GRAPH.addConnectedNode(Registry.VARIABLE, 
                                    RegistryConstants.FLUFF_EDGE, 
                                    Registry.INCOMING);
    }
}