/*
 * RegistryConstants.java
 *
 * Created on 21. Mrz 2003, 12:30
 */
package com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints;

import com.ai_center.dragonbreath.Registry;


/**
 * Used to register all the constraints needed with the Registry.
 * @author tim baermann
 * @version $Revision: 1.2 $
 */
public class RegistryConstants {
    //~ Static variables/initializers ******************************************

    public static int CRUFT_EDGE = -1;
    public static int FLUFF_EDGE;
    public static int FLUFF_FACTORY_A_CONSTRAINT;
    public static int FLUFF_FACTORY_AA_CONSTRAINT;
    public static int FLUFF_FACTORY_AAA_CONSTRAINT;
    public static int FLUFF_CHUTE_CONSTRAINT;
    public static int FLUFF_CONSTRAINT;
    public static int CRUFT_CONSTRAINT;
    public static int CRUFT_SUM_CONSTRAINT;
    public static int FLUFF_SUM_CONSTRAINT;

    /**
     * Used in CruftSumConstraint and FluffSumConstraint to determine how
     * probable a structural repair is.
     */
    public static double structRepProp = 0.0015;

    //~ Methods ****************************************************************

    public static void setStructRepProp(double val) {
        structRepProp = val;
    }


    public static double getStructRepProp() {
        return structRepProp;
    }


    public static void registerConstants() {
        if (CRUFT_EDGE == -1) {
            CRUFT_EDGE                   = Registry.registerEdgeType("cruft");
            FLUFF_EDGE                   = Registry.registerEdgeType("fluff");
            FLUFF_FACTORY_A_CONSTRAINT   = Registry.produceNodeTypeID();
            FLUFF_FACTORY_AA_CONSTRAINT  = Registry.produceNodeTypeID();
            FLUFF_FACTORY_AAA_CONSTRAINT = Registry.produceNodeTypeID();
            FLUFF_CHUTE_CONSTRAINT       = Registry.produceNodeTypeID();
            FLUFF_CONSTRAINT             = Registry.produceNodeTypeID();
            CRUFT_CONSTRAINT             = Registry.produceNodeTypeID();
            CRUFT_SUM_CONSTRAINT         = Registry.produceNodeTypeID();
            FLUFF_SUM_CONSTRAINT         = Registry.produceNodeTypeID();
            Registry.registerNodeType(FLUFF_FACTORY_A_CONSTRAINT, 
                                      "com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints.FluffFactoryAObjectConstraint");
            Registry.registerNodeType(FLUFF_FACTORY_AA_CONSTRAINT, 
                                      "com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints.FluffFactoryAAObjectConstraint");
            Registry.registerNodeType(FLUFF_FACTORY_AAA_CONSTRAINT, 
                                      "com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints.FluffFactoryAAAObjectConstraint");
            Registry.registerNodeType(FLUFF_CHUTE_CONSTRAINT, 
                                      "com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints.FluffChuteObjectConstraint");
            Registry.registerNodeType(FLUFF_CONSTRAINT, 
                                      "com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints.FluffObjectConstraint");
            Registry.registerNodeType(CRUFT_CONSTRAINT, 
                                      "com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints.CruftObjectConstraint");
            Registry.registerNodeType(FLUFF_SUM_CONSTRAINT, 
                                      "com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints.FluffSumConstraint");
            Registry.registerNodeType(CRUFT_SUM_CONSTRAINT, 
                                      "com.ai_center.dragonbreath.examples.structuralConstraintExample.fluffExampleConstraints.CruftSumConstraint");
        }
    }
}