/*
 * EmptyRepairPlan.java
 *
 * Created on 3. Dezember 2002, 14:52
 */
package com.ai_center.dragonbreath.graphRepair;

import com.ai_center.dragonbreath.*;


/**
 * Used when in GraphRepairer a function has to return a RepairPlan, but no
 * action is needed an Object of this class is returned.
 * 
 * @version $Revision: 1.2 $
 * @author tim baermann
 */
public class EmptyRepairPlan extends RepairPlan {
    // Constructors ***********************************************************

    /**
     * Creates a new instance of EmptyRepairPlan
     * 
     * @param graphrepairer The GraphRepairer that created the plan.
     */
    public EmptyRepairPlan(GraphRepairer graphrepairer) {
        super(graphrepairer);
    }

    // Methods ****************************************************************

    /**
     * Does nothing, as this is the empty RepairPlan.
     * 
     * @return null
     */
    public Object repair() {
        return null;
    }
}