/*
 * NodeChangedInterface.java
 *
 * Created on 7. April 2002, 15:03
 */
package com.ai_center.dragonbreath.structuralConstraintHandling;

import com.ai_center.dragonbreath.utilities.SetHashtable;

import java.util.Set;


/**
 * Interface for Objects that are interested in node changes.
 * For each change of nodes of the CSP-Graph these nodes are informed via this interface.
 * A change can be the addition and the removal of nodes and edges.
 * @version $Revision: 2.4 $
 * @author tim baermann
 */
public interface NodeChangedInterface {
    
    /**
     * Checks nodes that were newly changed for creation or destruction of
     * StructuralConstraintInstances.
     * 
     * @param newNodes  Nodes that were recently created.
     * @param deletedNodes  The nodes deleted.
     * @param expandedNodes  Expanded Nodes.
     * @param reducedNodes  The reduced Nodes.
     */
    public void checkChangedNodes(Set newNodes, Set deletedNodes, 
                                  Set expandedNodes, Set reducedNodes);
} //interface
