/*
 * MainPartInterface.java
 *
 * Created on 16. Oktober 2002, 17:31
 */
package com.ai_center.dragonbreath.structuralConstraintHandling.graph;

import com.ai_center.dragonbreath.structuralConstraintHandling.graph.applicationCondition.*;


/**
 * Implemented by all MainParts of Test- and of DockingGraphs.
 * 
 * @version $Revision: 1.2 $
 * @author tim baermann
 */
public interface MainPartInterface {
    // Methods ****************************************************************

    /**
     * Adds one ApplicationCondition to the list of PACs or NACs.
     * 
     * @param ac An ApplicationCondition.
     */
    public void addAC(ApplicationCondition ac);


    /**
     * Sets the interpretations as in the frame, then tries all the embeddings
     * possible with the frame, until an embedding is found with wich the  all
     * PACs are valid, or no more embeddings are possible, then saves the
     * frame with partlyFoundMatches or foundMatches. Is called for
     * DockingGraphs, when a PAC has got valid, and the frame for the MainPart
     * match  can be tried again, if it is valid now.
     * 
     * @param frame  A GraphPartFrame for this MainPart. it should be contained
     *        in partlyFoundParts.
     */
    public void checkFrame(GraphPartFrame frame);
}