/*
 * SCNodesComparator.java
 *
 * Created on 2. Mai 2002, 12:56
 */
package com.ai_center.dragonbreath.structuralConstraintHandling.graph;

import com.ai_center.dragonbreath.utilities.Pair;

import java.util.Comparator;


/**
 * Compares two Pairs, wich both have as first element a SCNode. The more edges
 * the node has the smaller is the object. Used in
 * StructuralConstraintGraphPart.tryNextBranch().
 * 
 * @version $Revision: 1.3 $
 * @author tim baermann
 */
public class SCNodesComparator implements Comparator {
    // Constructors ***********************************************************

    /**
     * Creates a new instance of SCNodesComparator
     */
    public SCNodesComparator() {
    }

    // Methods ****************************************************************

    /**
     * The node with less edges is bigger then the one with more edges
     * 
     * @param a
     * @param b
     * 
     * @return b.edges.size() - a.edges.size();
     */
    public int compare(Object a, Object b) {
        SCNode na = (SCNode) ((Pair) a).first;
        SCNode nb = (SCNode) ((Pair) b).first;

        return nb.edges.size() - na.edges.size();
    }
}