/*
 * DockingGraph.java
 *
 * Created on 27. Mai 2002, 17:38
 */
package com.ai_center.dragonbreath.structuralConstraintHandling.graph.dockingGraph;

import com.ai_center.dragonbreath.constraintgraph.Node;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.applicationCondition.ApplicationCondition;
import com.ai_center.dragonbreath.utilities.SetHashtable;

import java.math.BigInteger;

import java.util.*;


/**
 * The docking graph of a Structural constraint. Contains all the data shared
 * by SCIDockingGraph and SCTDockingGraph.
 * 
 * @version $Revision: 1.6 $
 * @author tim baermann
 */
public abstract class DockingGraph extends StructuralConstraintGraph {
    // Methods ****************************************************************

    /**
     * Returns a Hashcode of the graph with its actual mainParts
     * interpretations. (Therefore the graph needs a valid interpretation
     * first!)
     * 
     * @return A unique number.
     */
    public abstract BigInteger getHashCode();


    /**
     * Checks nodes that were newly created for creation or destruction of
     * StructuralConstraintInstances.
     */

    //public void checkChangedNodes(Set newNodes, Set deletedNodes, Set expandedNodes, Set reducedNodes);

    /**
     * Marks all the nodes used in the docking graph
     */
    public void mark() {
        Iterator it = interpretedNodes.keySet().iterator();

        while (it.hasNext()) {
            Node n = (Node) it.next();
            n.mark();
        }
    }


    /**
     * Marks all the nodes used in the docking graph
     */
    public void unmark() {
        Iterator it = interpretedNodes.keySet().iterator();

        while (it.hasNext()) {
            Node n = (Node) it.next();
            n.unmark();
        }
    }
}