/*
 * InstanceDockingNACPart.java
 *
 * Created on 14. Oktober 2002, 14:23
 */
package com.ai_center.dragonbreath.structuralConstraintHandling.graph.dockingGraph.applicationCondition.instance;

import com.ai_center.dragonbreath.constraintgraph.NodeType;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.applicationCondition.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.movableSubgraph.*;

import java.util.*;


/**
 * A part of a NAC of a DockingGraph. Used in StructuralConstraintInstance.
 * 
 * @version $Revision: 1.2 $
 * @author tim baermann
 */
public class InstanceDockingNACPart extends MovableSubgraphPart
    implements ApplicationConditionPart {
    // Constructors ***********************************************************

    /**
     * Creates a new instance of ApplicationConditionPart.
     * 
     * @param ac The StructuralConstraintGraph this part belongs to.
     */
    public InstanceDockingNACPart(ApplicationCondition ac) {
        super((MovableSubgraph) ac);

        //dl.switchOn(3);// uncomment for debug output
        //dl.switchOn(5);// uncomment for debug output
    }

    // Methods ****************************************************************

    /**
     * Returns the ApplicationCondition this part belongs to.
     * 
     * @return The mySubgraph member.
     */
    public ApplicationCondition getApplicationCondition() {
        return (ApplicationCondition) mySubgraph;
    }


    /**
     * Called from the ApplicationCondition if the Part was found, implemented
     * in the subclasses. Does nothing.
     * 
     * @return In subclasses: true if further search is necessary, eg. if no more
     *         mainParts are missing.
     */
    public boolean handleMatch() {
        return true;
    }


    /**
     * Called for every part of AC in ApplicationCondition.testAC(). Searches
     * for an embedding, and if none found initiates search for the ACPart to
     * create the mainPart when the ACPart is created.
     * 
     * @param mainPartFrame  A frame of the mainPart
     * 
     * @return true if the ACPart could be found, else false.
     */
    public boolean testAC(GraphPartFrame mainPartFrame) {
        return true;
    }


    /**
     * Called for every part of AC in ApplicationCondition.testPartAC().
     * Searches for an embedding, and if none found initiates search for the
     * ACPart to create the mainPart when the ACPart is created.
     * 
     * @param mainPartFrame  A frame of the mainPart
     * 
     * @return true if the ACPart could be found, else false.
     */
    public boolean testPartAC(GraphPartFrame mainPartFrame) {
        return true;
    }
}