/*
 * UnconnectedSCINACPart.java
 *
 * Created on 22. Juli 2002, 21:29
 */
package com.ai_center.dragonbreath.structuralConstraintHandling.graph.dockingGraph.applicationCondition.instance;

import com.ai_center.dragonbreath.constraintgraph.Node;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.StructuralConstraintGraphPart;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.applicationCondition.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.dockingGraph.applicationCondition.type.TypeDockingUnconnectedNACPart;

import java.util.*;


/**
 * A part of a NAC of a DockingGraphInstance that is not connected to any
 * MainPart.
 * 
 * @version $Revision: 1.3 $
 * @author tim baermann
 */
public class InstanceDockingUnconnectedNACPart extends UnconnectedACPart {
    // Instance variables *****************************************************

    /** 
     * The ApplicationCondition this NACPart belongs to. 
     */
    InstanceDockingNAC myAC;

    // Constructors ***********************************************************

    /**
     * Creates a new instance of UnconnectedSCTPACPart
     * 
     * @param ac The NAC this part belongs to.
     */
    public InstanceDockingUnconnectedNACPart(ApplicationCondition ac) {
        super(ac);
    }

    // Methods ****************************************************************

    /**
     * Returns the ApplicationCondition this part belongs to.
     * 
     * @return The mySubgraph member.
     */
    public ApplicationCondition getApplicationCondition() {
        return (ApplicationCondition) mySubgraph;
    }


    /**
     * Sets the given source as the myPartType member of this, so that its
     * seedInterpretations can be used.
     * 
     * @param source the graph with the interpretations
     */
    public void copyInterpretations(StructuralConstraintGraphPart source) {
        myPartType = (UnconnectedACPart) source;
    }
}