/*
 * UnconnectedSCIPACPart.java
 *
 * Created on 21. Juli 2002, 22:28
 */
package com.ai_center.dragonbreath.structuralConstraintHandling.graph.dockingGraph.applicationCondition.instance;

import com.ai_center.dragonbreath.structuralConstraintHandling.graph.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.applicationCondition.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.dockingGraph.applicationCondition.type.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.movableSubgraph.*;

import java.util.*;


/**
 * A part of a PAC of a DockingGraphInstance that is not connected to any
 * MainPart.
 * 
 * @version $Revision: 1.2 $
 * @author tim baermann
 */
public class InstanceDockingUnconnectedPACPart extends UnconnectedACPart {
    // Constructors ***********************************************************

    /**
     * Creates a new instance of UnconnectedSCTPACPart
     * 
     * @param ac The PAC this part belongs to.
     */
    public InstanceDockingUnconnectedPACPart(ApplicationCondition ac) {
        super(ac);
    }

    // Methods ****************************************************************

    /**
     * Returns the ApplicationCondition this part belongs to.
     * 
     * @return The mySubgraph member.
     */
    public ApplicationCondition getApplicationCondition() {
        return (ApplicationCondition) mySubgraph;
    }


    /**
     * Copies the interpretations of the other graph to this one. The two
     * graphs must be exactly identical in structure. Enters the source as
     * typePart.
     * 
     * @param source the graph with the interpretations
     */
    public void copyInterpretations(StructuralConstraintGraphPart source) {
        super.copyInterpretations(source);
        myPartType = (UnconnectedACPart) source;
    }


    /**
     * If the ApplicationConditionPart is not valid any more this function
     * registeres it at the Type for search, so that the Instance can be
     * recreated when the pac is valid again.
     */
    public void registerMissingMatch() {
        ApplicationCondition myTypesAC = ((ApplicationConditionPart) myPartType).getApplicationCondition();
        ((TypeDockingACPart) myPartType).registerMainPartFrame(
                myTypesAC.getAnyConnectedMainPartFrame());
    }
}