/*
 * TestGraphConnectedMainPart.java
 *
 * Created on 7. Februar 2003, 22:29
 */
package com.ai_center.dragonbreath.structuralConstraintHandling.graph.testGraph;

import com.ai_center.dragonbreath.structuralConstraintHandling.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.applicationCondition.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.movableSubgraph.*;

import java.util.*;


/**
 * A MainPart of a TestGraph that is linked to the dockinggraph.
 * 
 * @version $Revision: 1.2 $
 * @author tim baermann
 */
public class TestGraphConnectedMainPart extends MovableSubgraphPart
    implements MainPartInterface {
    // Instance variables *****************************************************

    /** 
     * The NACs of this graph 
     */
    protected HashSet NACs = new HashSet();

    // Constructors ***********************************************************

    /**
     * Creates a new instance of TestGraphConnectedMainPart
     * 
     * @param ms The MainParts of the TestGraph.
     */
    public TestGraphConnectedMainPart(MovableSubgraph mainparts) {
        super(mainparts);
    }

    // Methods ****************************************************************

    /**
     * Adds one ApplicationCondition to the list of PACs or NACs.
     * 
     * @param ac An ApplicationCondition.
     */
    public void addAC(ApplicationCondition ac) {
        NACs.add(ac);
    }


    /**
     * Sets the interpretations as in the frame, then tries all the embeddings
     * possible with the frame, until an embedding is found with wich the  all
     * PACs are valid, or no more embeddings are possible, then saves the
     * frame with partlyFoundMatches or foundMatches. Is called for
     * DockingGraphs, when a PAC has got valid, and the frame for the MainPart
     * match  can be tried again, if it is valid now.
     * 
     * @param frame  A GraphPartFrame for this MainPart. it should be contained
     *        in partlyFoundParts.
     */
    public void checkFrame(GraphPartFrame frame) {
    }
}