/*
 * TestNAC.java
 *
 * Created on 7. Oktober 2002, 12:34
 */
package com.ai_center.dragonbreath.structuralConstraintHandling.graph.testGraph.applicationCondition;

import com.ai_center.dragonbreath.structuralConstraintHandling.graph.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.applicationCondition.*;
import com.ai_center.dragonbreath.structuralConstraintHandling.graph.testGraph.*;

import java.util.*;


/**
 * a NAC of a TestGraph.
 * 
 * @version $Revision: 1.3 $
 * @author tim baermann
 */
public class TestNAC extends ApplicationCondition {
    // Instance variables *****************************************************

    /** 
     * If the NAC is fullfilled 1, else 0. 
     */
    int nacError;

    // Constructors ***********************************************************

    /**
     * Creates a new instance of TestNAC
     * 
     * @param scg The TestGraph this NAC belongs to.
     */
    public TestNAC(TestGraph scg) {
        super(scg);
        scg.addNAC(this);
    }

    // Methods ****************************************************************

    /**
     * If the NAC is fullfilled returns 1, else 0.
     * 
     * @return 0 or 1
     */
    public int getMinMatchError() {
        return nacError;
    }


    /**
     * Resets the nacError to 0.
     */
    public void resetNACError() {
        nacError = 0;
    }


    /**
     * Can the NAC be embedded?
     * 
     * @return Not all parts could be found.
     */
    public boolean testAC() {
        nacError = 0;

        boolean found = findAllParts();

        if (found) {
            nacError = 1;
        }

        return ! found;
    }
}