/*
 * AllCombinations.java
 *
 * Created on 11. Dezember 2001, 15:38
 */

package com.ai_center.dragonbreath.utilities;

/**
 * Computes all permutations of the given lists.
 * @author tim baermann
 * @version $Revision: 2.2 $
 */
public class AllCombinations {

    /** Creates new AllCombinations.
     */
    public AllCombinations() {
    }
    
    /**
     * The result of the search findAllCombinations is stored while search in here.
     */
    java.util.Vector result;
    /**
     * The actually generated list.
     */
    java.util.Vector actualCombination = new java.util.Vector();
    
    /**
     * A hashtable full of lists with the element to be assigned as key and all possible assignments as listvalue.
     */
    java.util.Hashtable allLists;
    
    /**
     * Randomizer for the position of the elements.
     */
    static java.util.Random randomizer = new java.util.Random();
    /**
     * A list of lists with the possible assignments for the elements.
     */
    java.util.ArrayList entries; 
    
    /**
     * Finds all combinations of given data, returns a list of lists with the combinations, where each assignment is used only once.
     * @param allLists allLists[i] contains a list with all possible assignments for object no i
     * @return All permutations each as a Vector
     */
   public java.util.Vector findAllCombinations(java.util.ArrayList allLists){
        result = new java.util.Vector();
        actualCombination.clear();
        
        entries = allLists;
        
        java.util.ListIterator actualEntry =   entries.listIterator();
        addElement(actualEntry);
        
        return result;
    }
    
     /** Recursive search for all permutations.
      * @param entryIt the actual element in entries
      */
    void addElement(java.util.ListIterator entryIt){
        
        if (entryIt.hasNext()){
            
            int index = entryIt.nextIndex();
            java.util.Vector possibleAssignments = (java.util.Vector) entryIt.next();
            
            java.util.Iterator it = possibleAssignments.iterator();
            while (it.hasNext()){//try all possible assignments
                Object actualAssignment = it.next();
                if (!actualCombination.contains(actualAssignment)){
                    
                    actualCombination.add(index,actualAssignment);
                    addElement(entryIt);
                    
                    int index1 = entryIt.nextIndex()-1;
                    actualCombination.remove(index);
                    
                }
            }//while 
        if (entryIt.hasPrevious()){entryIt.previous();}    
        } else { //keyNr>=keys.length: full assignment found
            java.util.Vector combo = (java.util.Vector) actualCombination.clone();
            result.add(combo);
        }//else*/
        
    }//addElement
    
}
