/*
 * debugLogger.java
 *
 * Created on 13. Juni 2002 18:41
 */

package com.ai_center.dragonbreath.utilities;

import com.ai_center.dragonbreath.constraintgraph.*;
import java.util.*;
/**                                         
 * Writes output to one of 100 streams, wich all print on the screen, 
 * but can be switched on and off.
 *
 * @author tim baermann
 * @version $Revision: 2.0 $
 */

public class DebugLogger {
    boolean isOn;
    int[] nrXon = new int[100];
    /** Creates a new instance of debugLogger */
    public DebugLogger(boolean on) {
        isOn = on;
    }//debugLogger()
    
    public void switchOn(int x){
        nrXon[x] = 1;
    }
    
    public void switchOn(){
        isOn = true;
    }
    
    public void switchOff(){
        isOn = false;
    }
    
    public void switchOff(int x){
            nrXon[x]= 0;
    }
    
    public void print(int x, Object s ){
        if ( isOn && (nrXon[x] == 1 ) ){
            System.out.print(s);
        }
    }
    
    public void print(int x, int s ){
        if ( isOn && (nrXon[x] == 1 ) ){
            System.out.print(s);
        }
    }
    public void print(int x, boolean s ){
        if ( isOn && (nrXon[x] == 1 ) ){
            System.out.print(s);
        }
    }
    public void print(int x, char s ){
        if ( isOn && (nrXon[x] == 1 ) ){
            System.out.print(s);
        }
    }
    public void print(int x, float s ){
       if ( isOn && (nrXon[x] == 1 ) ){
            System.out.print(s);
        }
    }
    
      public void printNodeList(int x, Object col ){
        if ( isOn && (nrXon[x] == 1 ) ){
              Iterator it;
            if ( col instanceof Map ){
                it = ( (Map) col).keySet().iterator();    
            } else if ( col instanceof AbstractCollection ){
                it = ( (AbstractCollection) col ).iterator();
            } else {
                return;
            }

             while  ( it.hasNext() ){
                    Node n = (Node) it.next();
                    if ( n instanceof Variable ) {
                        Variable  v = (Variable) n;
                        System.out.print(v.getName() + " ");
                    } else {
                        String prefix ="com.ai_center.dragonbreath.constraints.";
                        String name = n.toString();
                        if ( name.startsWith( prefix ) ){
                            name = name.substring(prefix.length() );
                        }
                        
                        System.out.print ( name + " ");
                    }
                }
        }
    }//printNodeList()           
}// debugLogger
/*
 * DO _NOT_ EDIT ANYTHING BELOW THIS POINT!
 *
 * $Log: DebugLogger.java,v $
 * Revision 2.0  2002/09/17 00:33:07  nareyek
 * work on beta version began: resource type, state tasks and precondition tasks introduced
 *
 * Revision 1.2  2002/08/08 22:17:35  nareyek
 * fixed minor issues
 *
 * Revision 1.1  2002/07/31 17:47:02  teutates
 * moved to utilities
 *
 * Revision 1.1  2002/07/25 01:01:38  teutates
 * tests for the matching
 *
 *
 */
