/*
 * IntValue.java
 *
 * Created on 9. November 2002, 17:33
 */

package com.ai_center.dragonbreath.utilities;

 /**
  * A class similar to Integer, with the difference that two members storing
  * the same value are not equal. 
  * Also the value can be changed after creation.
  */
    public class IntValue implements Comparable {
      
        
        public int value;

        public IntValue(int v) {
            value = v;
        }

        /**
         * Compares this object with the specified object for order.  Returns a
         * negative integer, zero, or a positive integer as this object is
         * less than, equal to, or greater than the specified object.
         * 
         * <p>
         * equals() is not compatible with compareTo() ! 
         * i.e. ! ((a.compareTo(b) == 0  => a.equals(b) )
         * </p>
         * 
         * @param o the Object to be compared.
         * 
         * @return a negative integer, zero, or a positive integer as this
         *         object     is less than, equal to, or greater than the
         *         specified object.
         */
        public int compareTo(Object o) {
            int result = value - ((IntValue) o).value;
            if ( o == this ) {
                return 0;
            } else if (result == 0) {
                return 1;
            }

            return result;
        }
        
        public String toString() {
            return "IntValue " + hashCode() + " : " + value;
        }
    } //class intValue
