package com.ai_center.planpresentation;

/**  Interface for all PluginLoaders.<p>
 
  This interfaces gives the possibility to load plugins on different techniques
  e.g. from directory, from .jar-files or over a network. <p>
 
 
  @author Daniel Weiss
  @version $Revision: 1.2 $
 */

public interface PluginLoader {
	
    /** Sets the link to the planPresentationAPI.<p>
      	
       @param pc The link to the PlanPresentationAPI.
     */
	public void setPlanPresentationAPI(PlanPresentationAPI pc);
	
	/** Loads the plugins */
	public void loadPlugins();

}
