package com.ai_center.planpresentation.plugins.actionconstraint;


import java.awt.Cursor;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import com.ai_center.planpresentation.utilities.MultiLevelController;
import com.ai_center.planpresentation.utilities.MultiLevelView;




/** The ActionCoordinatorView represents the Panel on top of all others
 in the planing area. <p>
 
 @author Daniel Weiss
 @version $Revision: 1.4 $
 */
public class ActionCoordinatorView extends MultiLevelView
        implements
            MouseListener
{


   
    /** True if a click should be catched and the addActionDialog should be 
     opend then. */
    private boolean mouseCatcherOn = false;

    /** Creates the ActionCoordinatorView
     @param _mlc The link to the ActionController. (ActionCoordinatorControlPlugin)
     
     @param _viewName The name of the view.
     */
    public ActionCoordinatorView(MultiLevelController _mlc, String _viewName)
    {
        super(_mlc, _viewName, false);
        // trace mouse clicks
        this.addMouseListener(this);

    }

    /* (non-Javadoc)
     * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
     */
    public void mouseClicked(MouseEvent arg0)
    {
        // nothing to do

    }


    /* (non-Javadoc)
     * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
     */
    public void mouseEntered(MouseEvent arg0)
    {
        // nothing to do
    }

    /* (non-Javadoc)
     * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
     */
    public void mouseExited(MouseEvent arg0)
    {
        // nothing to do
    }

    /*
     *  (non-Javadoc)
     * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
     */
    public void mousePressed(MouseEvent evt)
    {
        if (mouseCatcherOn)
        {
            // mouse click catched, open the addActionDialog with the prefilled
            // insert time.
            long actionBeginCT = this.convertCoordinatesToTime(evt.getX());

            ActionCoordinatorControlPlugin accp = (ActionCoordinatorControlPlugin) multiLevelController;
            accp.showAddActionDialog(actionBeginCT);
            accp.planPresentationAPI.getGuiFrame().setCursor(
                    Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
            accp.planPresentationAPI.setHelpText("");

            setMouseCatcherOn(false);
        }

    }

    /*
     *  (non-Javadoc)
     * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
     */
    public void mouseReleased(MouseEvent evt)
    {
        // nothing to do
    }

    /** This function activates the caching mechanism to open later the
     addActionDialog.<p>
     
     @param _mouseCatcherOn True if mouse clicks should be recorded.
     */
    public void setMouseCatcherOn(boolean _mouseCatcherOn)
    {
        mouseCatcherOn = _mouseCatcherOn;
    }

	/**
	 * @param endCT
	 */
	public void checkIfNewMaximumTime(int endCT) {
		if (mainViewModel.getMaximum() < endCT) {
			mainViewModel.setMaximum((int) (endCT * 1.1));
		}
		
	};

}