package com.ai_center.planpresentation.plugins.planplugin;


import java.awt.Dimension;
import java.awt.Graphics;

import javax.swing.JPanel;

import com.ai_center.planpresentation.PlanJFrame;
import com.ai_center.planpresentation.PlanPresentationConstants;




/** The AxisJPanel makes a jpanel with an axis inside. <p>
  
  @author Daniel Weiss
  @version $Revision: 1.2 $
 */
public class AxisJPanel extends JPanel implements PlanPresentationConstants
{

    /** The link to the PlanJFrame. */
    private PlanJFrame planGUI;

    /** Creates a new axis panel.
     * 
       @param _planGUI The link to the PlanJFrame.
     */
    public AxisJPanel(PlanJFrame _planGUI)
    {
        planGUI = _planGUI;
        this.setPreferredSize(new Dimension(10, 15));

    }

    /*
     *  (non-Javadoc)
     * @see java.awt.Component#paint(java.awt.Graphics)
     */
    public void paint(Graphics g)
    {
        super.paint(g);

        int axis = Axis.X_AXIS;
        int maxTics = 6;
        int ticLength = 4;
        int mainViewModelvalue = planGUI.mainViewModel.getValue();
        float lowVal = mainViewModelvalue;
        float highVal = mainViewModelvalue + planGUI.mainViewModel.getExtent();
        int screenStart = RETRACT_BUTTON_WIDTH;
        int screenEnd = getWidth() - 1;
        int screenOffset = 5;
        boolean logScale = false;
        int screenHeight = 3;

        Axis.drawAxis(axis, maxTics, ticLength, lowVal, highVal, screenStart,
                screenEnd, screenOffset, logScale, screenHeight, g);

    }
}

