package com.ai_center.planpresentation.plugins.stateresourceconstraint.numericalSRC;


import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.ai_center.dragonbreath.GlobalSearchControl;




/** The EditNumericalSensorDialog allows the input of real numbers for
  NumericalHeapStateResources.<p>
  
 
  @author Daniel Weiss
  @version $Revision: 1.1 $
 */
public class EditNumericalSensorDialog extends JDialog
        implements
            ActionListener
{

    /** The link to the GlobalSearchControl. */
    private GlobalSearchControl gsc;

    /** The link to the NumericalSRCControl. */
    private NumericalSRCControl numericalSRCControl;

    /** The main panel inside of the dialog window. */
    JPanel mainPanel = new JPanel();

    /** The panel which contains the buttons.*/
    JPanel buttonPanel = new JPanel();

    /** The cancel button. */
    JButton cancelButton = null;

    /** The ok button. */
    JButton okButton = null;

   
//    JLabel jLabel1 = new JLabel();

    /** The textfield, where the new sensor data can be entered. */
    JTextField textField = null;

    
    /** Creates an EditNumercialSensorDialog but does not open it.<p>
    
    @param frame The parent frame.
    @param title The title.
    @param modal If it should be modal.
    @param _numericalSRCControl The link to the controller.
    @param _gsc A link to the GlobalSearchControl.
    */
    public EditNumericalSensorDialog(Frame frame, String title, boolean modal,
            NumericalSRCControl _numericalSRCControl, GlobalSearchControl _gsc)
    {
        super(frame, title, modal);

        numericalSRCControl = _numericalSRCControl;
        gsc = _gsc;

        this.setLocation(200, 200);
        try
        {


            mainPanel.setLayout(new BorderLayout());

            textField = new JTextField(""
                    + numericalSRCControl.getNumericalHeapSRC().getHeap());
            textField.addKeyListener(new KeyAdapter()
            {


                public void keyTyped(KeyEvent e)
                {
                    char c = e.getKeyChar();
                    String content = textField.getText();
                    if (!((Character.isDigit(c)
                            || (c == KeyEvent.VK_BACK_SPACE)
                            || (c == KeyEvent.VK_DELETE) || (c == '.' && (content
                            .indexOf(".") == -1)))))
                    {
                        getToolkit().beep();
                        e.consume();
                    }
                }
            });

   //         mainPanel.add(jLabel1, BorderLayout.NORTH);
            mainPanel.add(textField, BorderLayout.CENTER);
            mainPanel.add(buttonPanel, BorderLayout.SOUTH);

            okButton = new JButton("OK");

            okButton.addActionListener(this);
            buttonPanel.add(okButton);

            cancelButton = new JButton("Cancel");
            cancelButton.addActionListener(this);
            buttonPanel.add(cancelButton);

            this.getContentPane().add(mainPanel, BorderLayout.NORTH);
            pack();
        } catch (Exception e)
        {
            e.printStackTrace();
        }
    }


    /* (non-Javadoc)
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e)
    {
        Object source = e.getSource();
        if (source instanceof JButton)
        {

            if (source == okButton)
            {
                javax.swing.SwingUtilities.invokeLater(new Runnable()
                {


                    public void run()
                    {

                        double heapValue = Double.parseDouble(textField
                                .getText());
                        numericalSRCControl.setHeap(heapValue);
                    }
                });

            }
            //else if (source == cancelButton) {}
            this.setVisible(false);
        }
    }


}