package com.ai_center.planpresentation.plugins.stateresourceconstraint.numericalSRC;


import java.awt.Graphics;

import javax.swing.JPanel;




/** The NumHSRCValuePanel represents the value of the total heap. <p>
 
 For that purpose it shows a horizontal line and the value of the heap.
 The horizontal line adjustes automatically to the global maximum over
 the whole time.
 
 @author Daniel Weiss
 @version $Revision: 1.2 $
 */
public class NumHSRCValuePanel extends JPanel
{


    /** The maximal heap until now. */
    private double maxHeap = 1.0;

    /** The actual totalHeap.*/
    private double totalHeap;


    /*
     *  (non-Javadoc)
     * @see java.awt.Component#paint(java.awt.Graphics)
     */
    public void paint(Graphics g)
    {
        super.paint(g);

        int height = this.getHeight() - 4;
        int lineHeight = 2 + (int) (height - ((totalHeap / maxHeap) * height));
        g.drawLine(0, lineHeight, this.getWidth(), lineHeight);
        g.drawString("Value: " + totalHeap, getWidth() / 2, 12);

    }

    /** Sets a new value for the heap
     @param _heap The new heap value.
     */
    public void setHeap(double _heap)
    {
        if (_heap > maxHeap)
        {
            maxHeap = _heap;
        }
        totalHeap = _heap;

    }
}