package com.ai_center.planpresentation.plugins.stateresourceconstraint.symbolicSRC;


import java.awt.Color;
import java.awt.Graphics;

import javax.swing.JLabel;
import javax.swing.border.LineBorder;

import com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc.SymSRCState;
import com.ai_center.planpresentation.PlanPresentationConstants;
import com.ai_center.planpresentation.utilities.DragablePanel;




/** The SymSRCStateSemanticGraphic reprents a State at the SymSRC. <p>

 More precisely it combines two or more interval elements, if they have the
 same stateID to one big state.

 @author Daniel Weiss
 @version $Revision: 1.4 $
 */
public class SymSRCStateSemanticGraphic extends DragablePanel
        implements PlanPresentationConstants
{


    /** The beginning of the state. */
    private long beginning = 0;

    /** The end of the state. */
    private long end = 0;

    /** The name of the state. */
    String stateName = null;

    /** The label, which displays the name of th state. */
    JLabel stateNameLabel = new JLabel();

    /** A link to the first state which begins this state sequence.*/
    private SymSRCState symSRCState = null;


    /** Creates a SymSRCStateSemanticGraphic object.

     @param state The first state of a sequence with the same stateIDs.
     @param _beginning The beginning time of the first state.
     @param _end The end time of the last state in this sequence.
     */
    public SymSRCStateSemanticGraphic(SymSRCState state, long _beginning,
            long _end)
    {
        beginning = _beginning;
        end = _end;
        symSRCState = state;

        stateNameLabel = new JLabel();
        this.setLayout(null);
        this.add(stateNameLabel);
        this.setToolTipText(stateName);
        stateNameLabel.setLocation(10, 5);
        stateNameLabel.setSize(400, 20);
        this.setBackground(STATE_COLOR);
        this.setBorder(new LineBorder(Color.black));
    }

    /*
     *  (non-Javadoc)
     * @see javax.swing.JComponent#paintComponent(java.awt.Graphics)
     */
    public void paintComponent(Graphics g)
    {
        synchronized (symSRCState)
        {
            if (symSRCState != null)
            {

                stateNameLabel.setText(prepareText(this.symSRCState.name,
                        getWidth()));
            }
        }
        super.paintComponent(g);

    }

    /** Sets a new location for the name of the state.<p>

     @param x The x-value inside of the state.
     */
    public void stateNameLabelLocation(int x)
    {
        stateNameLabel.setLocation(x, 5);
    }

}
