package com.ai_center.planpresentation.plugins.stateresourceconstraint.symbolicSRC;


import java.awt.Color;
import java.awt.Graphics;
import java.awt.datatransfer.Transferable;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DragSource;
import java.awt.dnd.DragSourceContext;
import java.awt.dnd.DragSourceDragEvent;
import java.awt.dnd.DragSourceDropEvent;
import java.awt.dnd.DragSourceEvent;
import java.awt.dnd.DragSourceListener;
import java.awt.dnd.InvalidDnDOperationException;
import java.awt.event.MouseEvent;
import java.util.LinkedList;

import javax.swing.BorderFactory;
import javax.swing.JLabel;

import com.ai_center.dragonbreath.constraintgraph.ConventionalConstraint;
import com.ai_center.dragonbreath.constraintgraph.Variable;
import com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc.SymSRCPreconditionTask;
import com.ai_center.dragonbreath.constraints.stateresourceconstraint.symbolicsrc.SymSRCStateTask;
import com.ai_center.planpresentation.PlanPresentationConstants;
import com.ai_center.planpresentation.SwimlaneConnector;
import com.ai_center.planpresentation.SwimlaneControl;
import com.ai_center.planpresentation.plugins.View;
import com.ai_center.planpresentation.utilities.ConstraintTransferable;
import com.ai_center.planpresentation.utilities.TaskSemanticGraphic;




/** The SymSRCTaskSemanticGraphic represents one PreconditionTask or
 one StateTask. <p>
 
 It supports Drag'n'Drop inside one Virtual Machine. 
 
 @author Daniel Weiss
 @version $Revision: 1.6 $
 */
public class SymSRCTaskSemanticGraphic extends TaskSemanticGraphic
        implements
            SwimlaneConnector,
            PlanPresentationConstants
{


    /** DGListener<p>
     A listener that will start the drag.
     has access to top level's dsListener and dragSource
     @see java.awt.dnd.DragGestureListener
     @see java.awt.dnd.DragSource
     @see java.awt.datatransfer.StringSelection      
     */
    class DGListener implements DragGestureListener
    {


        /*
         *  (non-Javadoc)
         * @see java.awt.dnd.DragGestureListener#dragGestureRecognized(java.awt.dnd.DragGestureEvent)
         */
        public void dragGestureRecognized(DragGestureEvent e)
        {

            // if the action is ok we go ahead
            // otherwise we punt
            if ((e.getDragAction() & SymSRCTaskSemanticGraphic.this.dragAction) == 0)
                return;

            // get the label's text and put it inside a Transferable
            // Transferable transferable = new StringSelection( DragLabel.this.getText() );
            Transferable transferable = new ConstraintTransferable(
                    (ConventionalConstraint) task);
            //new StringTransferable( DragLabel.this.getText() );     
            /*   GlobalSearchControl gsc = stateResourceView
                    .getGlobalSearchControl();
            StateResourceConstraint src = stateResourceView.getStateResourceConstraint();
            
            
            Node task2 = (Node) task;
            ConventionalConstraint taskConstraint = (ConventionalConstraint) task;
           
            
            
          delete after at dragOK Embedding emb = new Embedding(1);
            gsc.extendEmbedding(emb, (Node) task, Registry.PLAIN_EDGE,
                    Registry.INCOMING);
            gsc.reduceConstraint(
                    stateResourceView.getStateResourceConstraint(), emb);
*/
            // now kick off the drag
            try
            {
                // initial cursor, transferrable, dsource listener      
                e.startDrag(DragSource.DefaultMoveDrop, transferable,
                        SymSRCTaskSemanticGraphic.this.dsListener);


            } catch (InvalidDnDOperationException idoe)
            {
                System.err.println(idoe);
            }
        }
    }

    /** DSListener<p>
     a listener that will track the state of the DnD operation
     
     @see java.awt.dnd.DragSourceListener
     @see java.awt.dnd.DragSource
     @see java.awt.datatransfer.StringSelection      
     */
    class DSListener implements DragSourceListener
    {


        /*
         *  (non-Javadoc)
         * @see java.awt.dnd.DragSourceListener#dragDropEnd(java.awt.dnd.DragSourceDropEvent)
         */
        public void dragDropEnd(DragSourceDropEvent e)
        {
        }

        /*
         *  (non-Javadoc)
         * @see java.awt.dnd.DragSourceListener#dragEnter(java.awt.dnd.DragSourceDragEvent)
         */
        public void dragEnter(DragSourceDragEvent e)
        {
            DragSourceContext context = e.getDragSourceContext();
            //intersection of the users selected action, and the source and target actions
            int myaction = e.getDropAction();
            if ((myaction & SymSRCTaskSemanticGraphic.this.dragAction) != 0)
            {
                context.setCursor(null);
                context.setCursor(DragSource.DefaultMoveDrop);
            } else
            {
                context.setCursor(null);
                context.setCursor(DragSource.DefaultMoveNoDrop);
            }
        }

        /*
         *  (non-Javadoc)
         * @see java.awt.dnd.DragSourceListener#dragExit(java.awt.dnd.DragSourceEvent)
         */
        public void dragExit(DragSourceEvent e)
        {
            DragSourceContext context = e.getDragSourceContext();
        }

        /*
         *  (non-Javadoc)
         * @see java.awt.dnd.DragSourceListener#dropActionChanged(java.awt.dnd.DragSourceDragEvent)
         */
        public void dragOver(DragSourceDragEvent e)
        {
        }

        /*
         *  (non-Javadoc)
         * @see java.awt.dnd.DragSourceListener#dropActionChanged(java.awt.dnd.DragSourceDragEvent)
         */
        public void dropActionChanged(DragSourceDragEvent e)
        {
            DragSourceContext context = e.getDragSourceContext();
            context.setCursor(DragSource.DefaultCopyNoDrop);
        }

    }

    /** The begin time (and end time) of this task. */
    private long beginCT;

    /** The duration of the task. Normally zero, but to show something on screen
     the duration is adjusted by the SymbolicStateResourceView. */
    private long duration;

    /** A link to the DragGestureListener. */
    private DragGestureListener dgListener;

    /** A link to the DragSourceListener. */
    private DragSourceListener dsListener;

    /** A link to the DragSource. */
    private DragSource dragSource;

    /** The only allowed drag action. */
    private int dragAction = DnDConstants.ACTION_MOVE;

    /** A link to the Precondition- or StateTask. */
    private Object specializedTask = null;

    /** A link to the SymbolicStateResourceView. */
    private SymbolicStateResourceView stateResourceView;

    /** A link to the temporal Reference Variable. */
    private Variable temporalReferenceVariable = null;

    /** The textLabel, which shows the name of the task. */
    private JLabel textLabel = new JLabel();

    /** Creates a SymSRCTaskSemanticGraphic.<p>
     
     <pre>
     * taskSemanticGraphic = new SymSRCTaskSemanticGraphic(
     *                      swimlaneControl, this, stateTask.taskConstraint,
     *                      stateTask);
     </pre>
     
     @param _swimlaneControl A link to the SwimlaneControl.
     @param _stateResourceView The link to the SymbolicStateResourceView.
     @param _task The task which is represented as ObjectConstraint.
     @param _specializedTask The specialized, interal version of the task.
     */
    public SymSRCTaskSemanticGraphic(SwimlaneControl _swimlaneControl,
            SymbolicStateResourceView _stateResourceView, Object _task,
            Object _specializedTask)
    {
        super(_swimlaneControl, _task, (View) _stateResourceView);

        stateResourceView = _stateResourceView;
        specializedTask = _specializedTask;
        if (specializedTask != null)
        {
            if (specializedTask instanceof SymSRCPreconditionTask)
            {
                SymSRCPreconditionTask preconditionTask = (SymSRCPreconditionTask) specializedTask;
                temporalReferenceVariable = preconditionTask.tempVariable;
            } else if (specializedTask instanceof SymSRCStateTask)
            {
                SymSRCStateTask stateTask = (SymSRCStateTask) specializedTask;
                temporalReferenceVariable = stateTask.tempVariable;
            }
        }

        this.add(textLabel);

        this.dragSource = DragSource.getDefaultDragSource();
        this.dgListener = new DGListener();
        this.dsListener = new DSListener();

        // component, action, listener
        this.dragSource.createDefaultDragGestureRecognizer(this,
                this.dragAction, this.dgListener);
        this.setBorder(BorderFactory.createLineBorder(Color.black,1));

    }

    /** Sets a new value for the temporal reference variable.<p>
     
     @param tempCT The new value of the temporalReferenceVariable.
     */
    private void setTemporalReference(long tempCT)
    {
        if (temporalReferenceVariable != null)
        {
            stateResourceView.getGlobalSearchControl().setVariable(
                    temporalReferenceVariable, tempCT);
        }

    }

    /* (non-Javadoc)
     * @see com.ai_center.planpresentation.utilities.SemanticGraphic#getBeginCT()
     */
    public long getBeginCT()
    {

        return beginCT;
    }

    /* (non-Javadoc)
     * @see com.ai_center.planpresentation.SwimlaneConnector#getConnectorX(int)
     */
    public int getConnectorX(int connectionType)
    {

        if (connectionType < 0)
        {
            // state <-> task connection on the left side.
            return this.getX();
        } else
        {
            // probably action <-> task connection.
            return this.getX();
        }

    }

    /* (non-Javadoc)
     * @see com.ai_center.planpresentation.SwimlaneConnector#getConnectorY(int)
     */
    public int getConnectorY(int connectionType)
    {
        if (connectionType < 0)
        {
            // this is a task <-> state connection (connectionType == -x coordinate)
            return absoluteY(0); // connection from the left bottom end. 

        } else
        {
            return absoluteY(connectionType + 5);
        }

    }

    /* (non-Javadoc)
     * @see com.ai_center.planpresentation.utilities.SemanticGraphic#getDuration()
     */
    public long getDuration()
    {

        return duration;
    }

    /* (non-Javadoc)
     * @see com.ai_center.planpresentation.SwimlaneConnector#getPosition(int)
     */
    public int getPosition(int connectionType)
    {
        if (connectionType < 0)
        {
            // this is a connection between task <-> state. No x difference,
            // connection on the SOUTH end.
            return SwimlaneConnector.NORTH;
        }
        return 0;
    }

    /*
     *  (non-Javadoc)
     * @see java.awt.event.MouseMotionListener#mouseDragged(java.awt.event.MouseEvent)
     */
    public void mouseDragged(MouseEvent evt)
    {
        // this mouseDragged function is overwritten to catch mouseDragged calls, 
        // so that DragablePanel does not start a local dragging.
    }

    /*
     *  (non-Javadoc)
     * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
     */
    public void mouseReleased(MouseEvent evt)
    {
        super.mouseReleased(evt);

        long tempCT = convertCoordinatesToTime(this.getX());//stateResourceView.convertCoordinatesToTime(this.getX());
        setTemporalReference(tempCT);

    }

    /*
     *  (non-Javadoc)
     * @see java.awt.Component#paint(java.awt.Graphics)
     */
    public void paint(Graphics g)
    {
        super.paint(g);
        g.drawLine(0, 0, 0, this.getHeight());
    }

    /** Creates a new swimlane from the task to the state.<p>
     
     */
    public void requestSwimlane()
    {
        // connectionType = -1 * x, because SymbolicView doesn't need a model for the connectionTypes.
        int x = this.getX();
        this.requestSwimlane(-x);

    }

    /*
     *  (non-Javadoc)
     * @see com.ai_center.planpresentation.utilities.TaskSemanticGraphic#requestSwimlane(int)
     */
    public void requestSwimlane(int connectionType)
    {
        if (task != null)
        {

            connectorList = new LinkedList();
            connectorList.add(task);
            connectorList.add(stateResourceView.getStateResourceConstraint());
            swimlaneControl.requestSwimlane(connectionType,
                    (SwimlaneConnector) this, connectorList);
        }
    }

    /** Sets a new value for the beginCT (but only in the gui).<p>
     
     @param _beginCT The new value for the begin time.
     */
    public void setBeginCT(long _beginCT)
    {
        beginCT = _beginCT;

    }


    /* (non-Javadoc)
     * @see com.ai_center.planpresentation.SwimlaneConnector#setPriorityOffset(int)
     */
    public void setPriorityOffset(long offset)
    {
        // this is not a view. Nothing to do

    }

    /* (non-Javadoc)
     * @see com.ai_center.planpresentation.utilities.SemanticGraphic#setShouldVisible(boolean)
     */
    public void setShouldVisible(boolean b)
    {

    }

    /* (non-Javadoc)
     * @see com.ai_center.planpresentation.utilities.SemanticGraphic#setSwimlaneVisibility(boolean)
     */
    public void setSwimlaneVisibility(boolean b)
    {

    }

    /** Sets a new text for the label inside of this task.<p>
     
     e.g. used to show the name of the task.
     @param text The new text to set.
     */
    public void setText(String text)
    {
       // textLabel.setText(prepareText(text, 40)); adds dots at the end of the line, if text is too long
    	textLabel.setText(text);

    }
    
    /** Returns the description text for this SymSRCTaskSemanticGraphic Element
      
      @return The description text.
     */
    public String getText() 
    {
     return textLabel.getText();	
    }

    /* (non-Javadoc)
     * @see com.ai_center.planpresentation.utilities.SemanticGraphic#shouldVisible()
     */
    public boolean shouldVisible()
    {
        return true;
    }

    /**
     @param duration The duration to set.
     */
    public void setDuration(long duration)
    {
        this.duration = duration;
    }
}