package com.ai_center.planpresentation.utilities;


import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.EventListenerList;




/** This class adds basic observer function. <p>
 
 @author Daniel Weiss
 @version $Revision: 1.2 $
 */
public class Observable
{


    /** The EventListenerList */
    private EventListenerList listenerList = new EventListenerList();

    /** Adds a ChangeListener.<p>
     
     @param l The ChangeListener to add.
     */
    public void addChangeListener(ChangeListener l)
    {
        listenerList.add(ChangeListener.class, (ChangeListener) l);

    }

    /** Removes a ChangeListener.<p>
     
     @param l The ChangeListener to remove.
     */
    public void removeChangeListener(ChangeListener l)
    {
        listenerList.remove(ChangeListener.class, (ChangeListener) l);
    }

    /** Informs all ChangeListeners about a ChangeEvent.<p>
     
     @param changedObject The object which has changed.
     */
    protected void fireChange(Object changedObject)
    {
        ChangeEvent changeEvent = new ChangeEvent(changedObject);

        Object[] listeners = listenerList.getListenerList();
        ChangeListener listener = null;

        for (int i = listeners.length - 2; i >= 0; i -= 2)
        {
            if (listeners[i] == ChangeListener.class)
            {

                ((ChangeListener) listeners[i + 1]).stateChanged(changeEvent);

            }

        }
    }
}