package com.ai_center.planpresentation.utilities;


import javax.swing.event.ChangeListener;




/** The ResourceController is a special controller for Resources. <p>
 
 It is normaly used at StateResources or ActionResources, where a
 representation in a JList and an additional representation with a
 view frame is needed.
 
 @author Daniel Weiss
 @version $Revision: 1.2 $
 */
public interface ResourceController
{


    /** Adds a ChangeListener to the controller.<p>

     @param l The ChangeListener to add.
     */
    void addChangeListener(ChangeListener l);

    /** Gets the last access time from the datamodel.<p>
     
     @return The last access time.
     */
    long getAccessTime();

    /** Returns a refernce to the datamodel.
     @return The reference to the datamodel.
     */
    Object getDatamodel();

    /** Returns the name of the ResourceController.<p>
     
     @return The name of the ResourceController.
     */
    String getName();

    /** Returns the speedmode.<p>
     
     @return The speed mode  */
    int getSpeedMode();


    /** This function is called, when the ResourceController is clicked
     in the JList.<p> */
    void onClick();

    /** Sets a new name for this ResourceController.<p>
     @param name The new Name.
     */
    void setName(String name);

    /** Sets a new priorityOffset.<p>
     @param priorityOffset The new priorityOffset
     */
    void setPriorityOffset(long priorityOffset);
}